#include <avr/io.h>
#include <avr/interrupt.h>

#include <stdint.h>

#include "rf.h"


// FixMe: remove
#include <stdio.h>
extern void uart_dump_buffer(uint8_t *data, size_t len);


volatile static int rf_buf_tx_busy_a;
volatile static int rf_buf_tx_busy_b;
static uint8_t rf_buf_tx_a[16];
static uint8_t rf_buf_tx_b[16];

static uint8_t rf_tx_buf[2][16];
volatile static char rf_tx_buf_head, rf_tx_buf_tail;
volatile static int rf_tx_offset;



// bitrate routine
//ISR(TIMER1_COMPA_vect) {
//    cli();

//    if (rf_buf_tx_busy_a == 1) {
//        printf("%02x ", rf_buf_tx_a[tx_offset]);
//        if (++tx_offset >= sizeof(rf_buf_tx_a)) {
//            tx_offset = 0;
//            rf_buf_tx_busy_a = 0;
//            printf("a\r\n");
//        }
//    } else if (rf_buf_tx_busy_b == 1) {
//        printf("%02x ", rf_buf_tx_b[tx_offset]);
//        if (++tx_offset >= sizeof(rf_buf_tx_b)) {
//            tx_offset = 0;
//            rf_buf_tx_busy_b = 0;
//            printf("b\r\n");
//        }
//    }

//    if (rf_tx_buf_head != rf_tx_buf_tail) {
//        printf("%02x ", rf_tx_buf[rf_tx_buf_head][rf_tx_offset]);
//        if (++rf_tx_offset >= /*sizeof(rf_tx_buf[0])*/16) {
//            rf_tx_offset = 0;
//            rf_tx_buf_head = (rf_tx_buf_head + 1) % 2;
//            printf("%d - %d\r\n", rf_tx_buf_head, rf_tx_buf_tail);
//        }
//    }

//    sei();
//}




static void rf_encode(uint8_t c, uint8_t *buf) {
    int i;

    for (i = 0; i < 8; i++) {
        if (c & 0x01) {
            *buf++ = 1;
            *buf++ = 0;
        } else {
            *buf++ = 0;
            *buf++ = 1;
        }
        c = (c >> 1);
    }
}

/*static */void rf_send_byte(uint8_t c) {
//    while(rf_tx_buf_head == rf_tx_buf_tail && rf_tx_offset != 0);

printf("s 0x%x\r\n", c);
    rf_encode(c, rf_tx_buf[rf_tx_buf_tail]);
    rf_tx_buf_tail = (rf_tx_buf_tail + 1) % 2;
    while(rf_tx_buf_head == rf_tx_buf_tail);

//    for (;;) {
//        if (rf_buf_tx_busy_a == 0) {
//            rf_encode(c, rf_buf_tx_a);
//            rf_buf_tx_busy_a = 1;
//            break;
//        } else if (rf_buf_tx_busy_b == 0) {
//            rf_encode(c, rf_buf_tx_b);
//            rf_buf_tx_busy_b = 1;
//            break;
//        }
//    }

    // FixMe: return false
}


void rf_tx_start() {
//    rf_buf_tx_busy_a = 0;
//    rf_buf_tx_busy_b = 0;

    rf_tx_buf_head = 0;
    rf_tx_buf_tail = 0;
    rf_tx_offset = 0;

    TCNT1 = 0;
    TIMSK |= _BV(OCIE1A);
}

void rf_tx_stop() {
    TIMSK &= ~_BV(OCIE1A);
}


void rf_init() {
    // TX TIMER
    TCCR1B = _BV(WGM12) | _BV(CS12)/* | ~_BV(CS11) */ | _BV(CS10);
    OCR1A  = 3333;  // 16000000Hz / 4800Hz
    //OCR1A  = 15625;

    rf_tx_start();
}

//void
