#ifndef __VIRTUALWIRECONF_H_
#define __VIRTUALWIRECONF_H_



// PC3 - Rx
// PC6 - Tx

#define VM_TX_PIN_INIT()    \
    DDRC |= _BV(6)
#define VM_TX_PIN_SET(v)    \
    if ((v) == 0) PORTC &= ~_BV(6); else PORTC |= _BV(6)

#define VM_RX_PIN_INIT()    \
    DDRC &= ~_BV(3);        \
    PORTC |= _BV(3)
#define VM_RX_PIN_GET()     \
    (PINC & _BV(3))



#endif // __VIRTUALWIRECONF_H_
