#ifndef __LEAKAGE_H_
#define __LEAKAGE_H_

#include <stdint.h>



#define LK_STATUS_OK            0
#define LK_STATUS_ERROR         1
#define LK_STATUS_LEAK          2


#define LK_SENSOR_THRESHOLD     300
#define LK_LEAKAGE_THRESHOLD    1400
#define LK_MEASURE_THRESHOLD    6000



void lk_init();

uint8_t lk_get_state();
uint16_t lk_get_val();

void lk_poll();



#endif // __LEAKAGE_H_
