#ifndef __LED_H_
#define __LED_H_



#define LED_VALVE_CLOSE     0
#define LED_VALVE_OPEN      1
#define LED_VALVE_MANUAL    2

#define LED_TX              3
#define LED_RX              4

#define LED_PWR_LINE        5
#define LED_PWR_BAT         6

#define LED_LEAKAGE         7


#define LED_OFF             0
#define LED_ON              1
#define LED_FLASH           2
#define LED_FLASH_INV       3
#define LED_BLINK           4



void led_init();
void led_set(uint8_t id, uint8_t val);
void led_poll();



#endif // __LED_H_
