#ifndef __POWER_H_
#define __POWER_H_



#define PWR_STATE_ONLINE            0
#define PWR_STATE_ONLINE_CHARGE     1
#define PWR_STATE_BAT               2
#define PWR_STATE_BATALARM          3
#define PWR_STATE_BATLOW            4



void pwr_init();
void pwr_poll();
uint8_t pwr_get_state();

uint8_t pwr_get_charge();
int16_t pwr_get_line();
int16_t pwr_get_bat();



#endif // __POWER_H_
