#ifndef __VALVE_H_I
#define __VALVE_H_



#define VALVE_STATE_ERROR       0
#define VALVE_STATE_WAIT_CLOSE  1
#define VALVE_STATE_CLOSE       2
#define VALVE_STATE_WAIT_OPEN   3
#define VALVE_STATE_OPEN        4

#define VALVE_COMMAND_UNDEFINED 0
#define VALVE_COMMAND_CLOSE     1
#define VALVE_COMMAND_OPEN      2


void valve_init();

void valve_close();
void valve_open();

uint8_t valve_get_state();

void valve_poll();



#endif // VALVE_H_INCLUDED
